
//
// Note: This effect file does not work with EffectEdit.
//
#define C_MAT_VIEWPROJ             0
#define C_EYE                      4
#define C_MAT_INVERSE_VIEW         5

// Pixel Shader Constants
#define P_SPECULAR                 1
#define P_Diffuse                2


#define C_LIGHTPOS                 9

float4 COMMONCONST=float4(0,0.5,1,2);
float4 PIVECTOR=float4(4.0f,1.57080,3.14159,6.28319);
float4 SIN7=float4(1,-0.16667,0.00833,-0.00020);
float4 COS8=float4(0.5,-0.04167,0.00139,-0.00002);
float4 LIGHTPOS=float4(0.0f, 0.0f, 0.0f, 1.0f);
float4 FRCFIXUP=float4(0.98,0.003,0,0);
float4 WAVEHEIGHTS=float4(1.0f, 1.0f, 1.0f, 1.0f);
float4 WAVEOFFSET=float4(0,0.2,0,0);
float4 WAVESPEED=float4(1.0f, 1.0f, 1.0f, 1.0f);
float4 WAVEDIRX=float4(1.0f, 1.0f, 1.0f, 1.0f);
float4 WAVEDIRY=float4(1.0f, 1.0f, 1.0f, 1.0f);
float4 TIME=float4(1.0f, 1.0f, 1.0f, 1.0f);
float4 SINTIME=float4(1.0f, 1.0f, 1.0f, 1.0f);
float4 BUMPSPEED=float4(1.0f, 1.0f, 1.0f, 1.0f);
float4 TEXCOORD_DISTORSION=float4(1.0f, 1.0f, 1.0f, 1.0f);


// transformations
float4x4 World      : WORLD;
float4x4 View       : VIEW;
float4x4 MAT_INVERSE_VIEW    ;
float4x4 Projection : PROJECTION;

// eye position
float3 Eye;

float4 Specular=float4(1.0f, 1.0f, 1.0f, 1.0f);
float4 Ticks=float4(1.0f, 1.0f, 1.0f, 1.0f);
float3 Ticks2=float3(1.0f, 1.0f, 1.0f);

static const float4 vOne = float4(1, 1, 1, 1);

// Textures 
// Defined by effect ...

texture tex_BumpMap;

texture tex_Water;

texture tex_EnvMap;


// vertex shaders
VertexShader Metal_VS = asm
{ 
  vs.1.1

dcl_position   v0
dcl_normal     v1
dcl_texcoord   v2  
dcl_color0   v4

//dcl_tangent    v3
//dcl_binormal   v4

// output vertex position
m4x4 oPos, v0, c0

// output texture coordinates
mov oT0, v2

// output normal vector
mov oT2, v1

// find the light position in object space
mov  r0, c9
m4x4 r1, r0, c5

// find light vector
sub  r1, r1, v0

// normalize light vector
dp3  r2.x, r1, r1
rsq  r2.x, r2.x
mul  r1.xyz, r1.xyz, r2.xxx

// output light vector
mov oT1, r1

// find the eye position in object space
mov  r0, c4
m4x4 r2, r0, c5

// find eye vector
sub  r2, r2, v0

// normalize eye vector
dp3  r3.x, r2, r2
rsq  r3.x, r3.x
mul  r2.xyz, r2.xyz, r3.xxx

// output eye vector
mov oT4, r2

// find half angle vector
add r3, r1, r2
mul r3, r3, c10.yyy

// normalize half angle vector
dp3  r4.x, r3, r3
rsq  r4.x, r4.x
mul  r3.xyz, r3, r4.xxx

mov r3.xy, v1.xy

// normalize half angle vector
dp3  r4.x, r3, r3
rsq  r4.x, r4.x
mul  r3.xyz, r3, r4.xxx

// output half angle vector vector
mov oT3, r3




};

      
// Pixel shaders
PixelShader Water_PS = asm
{ps.1.4

def c0, 0.0f, 0.0f, 0.0f, 1.0f
def c1, 1.0f, 1.0f, 1.0f, 1.0f
def c2, 11.0f, 11.0f, 11.0f, 11.0f

texcrd r0.rgb, t0  // env map
texcrd r1.rgb, t1  // L
texcrd r2.rgb, t2  // N
texcrd r3.rgb, t3  // H
texcrd r4.rgb, t4  // V

// N.L
dp3 r5, r2, r1

// offset basemap
mov r0.a, c0.a
add r0, r0, r5

// N.H
dp3 r4.r, r2, r3

// H.H (aka ||H||^2)
dp3 r4.g, r3, r3
mov r4.g, 1-r4.g

phase

texld  r1, r4       // N.H^k
texld  r0, r0       // base

mul r1.rgb, r1, r5
mul r1.rgb, r1, c1


add_sat r0, r0, r1





} ;

// techniques
technique Init
{
    pass P0
    {
        // render states
       // CullMode = NONE;

    //    AmbientMaterialSource = COLOR1;
    //    DiffuseMaterialSource = COLOR1;

    //    BlendOp   = ADD;
    //    SrcBlend  = SRCALPHA;
    //    DestBlend = INVSRCALPHA;

   //     AlphaTestEnable = FALSE;
   //     AlphaFunc       = GREATER;
   //     AlphaRef        = 0;

  //      AlphaBlendEnable = TRUE;

        // texture stage states
 //       AlphaOp[0]   = MODULATE;
  //      AlphaArg1[0] = TEXTURE;
  //      AlphaArg2[0] = CURRENT;


 //       Lighting = FALSE;


        // transforms
        ViewTransform       = (View);
        ProjectionTransform = (Projection);
   }
}
sampler ClampedLinear = 
sampler_state
{
    AddressU  = CLAMP;
    AddressV  = CLAMP;
    AddressW  = CLAMP;
    MipFilter = NONE;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

technique Metal
{
    pass P0
    {
        // render states
        AlphaTestEnable  = TRUE;

        // texture

        // vertex shader
      VertexShader = (Metal_VS);
          PixelShader = (Water_PS);


         
        Sampler[0]  = (ClampedLinear);
     Sampler[1]  = (ClampedLinear);
     Sampler[2]  = (ClampedLinear);
     Sampler[3]  = (ClampedLinear);


        Lighting = FALSE;

     // Texture[0] = (tex_BumpMap);
     // Texture[1] = (tex_BumpMap);
    //  Texture[2] = (tex_Water);
      //    Texture[3] = (tex_EnvMap);


        VertexShaderConstantF[C_MAT_VIEWPROJ]      = ( mul(mul(World, View), Projection));
         VertexShaderConstantF[C_EYE]      = (Eye);
        VertexShaderConstantF[C_LIGHTPOS]      = (LIGHTPOS);
           VertexShaderConstantF[C_MAT_INVERSE_VIEW]      = ( MAT_INVERSE_VIEW);
         PixelShaderConstant[P_SPECULAR]=  (1.0f,1.0f,1.0f,1.0f);
         PixelShaderConstant[P_Diffuse]= (1.0f,1.0f,1.0f,1.0f);

    }
}
